#!/bin/bash

# Функція для перевірки наявності пакету і встановлення його, якщо потрібно
install_package_if_missing() {
    local package_name=$1
    if ! dpkg -l | grep -q "ii  $package_name "; then
        echo "$package_name is not installed. Installing..."
        sudo apt update
        sudo apt install -y "$package_name"
        echo "$package_name has been installed."
    else
        echo "$package_name is already installed."
    fi
}

# Перевірка та встановлення Python 3
if ! command -v python3 &>/dev/null; then
    echo "Python 3.x is not installed. Installing..."
    sudo apt update
    sudo apt install -y python3
    echo "Python 3.x has been installed."
else
    echo "Python 3.x is already installed."
fi

# Перевірка та встановлення libmysqlclient-dev
install_package_if_missing "libmysqlclient-dev"

# Перевірка та встановлення libpq-dev
install_package_if_missing "libpq-dev"

# Перевірка та встановлення pip для Python 3
if ! command -v pip3 &>/dev/null; then
    echo "pip for Python 3 is not installed. Installing..."
    sudo apt update
    sudo apt install -y python3-pip
    echo "pip for Python 3 has been installed."
else
    echo "pip for Python 3 is already installed."
fi

# Перевірка та встановлення python-venv
if ! dpkg -l | grep -q "ii  python3-venv "; then
    echo "python-venv is not installed. Installing..."
    sudo apt update
    sudo apt install -y python3-venv
    echo "python-venv has been installed."
else
    echo "python-venv is already installed."
fi

