from datetime import datetime, timedelta

from flask_mail import Mail, Message
from flask import render_template_string, flash
import logging

from k2.k2cfg import K2
from k2.k2obj import K2Obj
try:
    from components.k2site.k2site.models import K2Emails
except Exception as ex:
    logging.error(f"{ex} K2Site is missing for correct work")
from app import app
db = K2.db
time_zone = K2.timezone


class K2Mail(K2Obj):

    mail_server = 'relay.corp2.eu' #'192.168.20.226'
    mail_port = '465'
    mail_use_tls = 'False'
    mail_use_ssl = 'True'
    mail_username = 'nobody@corp2.eu'
    mail_password = 'Bdfiue03Db'
    mail_default_sender = 'nobody@corp2.eu'

    def __init__(self, *args, **kwargs):
        super().__init__()

    def send_email(self, subject, email, email_template, redirect_url=None):
        '''Function send email'''
        try:
            #Read the template from the file
            with app.open_resource(email_template) as f:
                template = f.read().decode('utf-8')
            # Render the template with variables
            email_body = render_template_string(template, user_email=email, reset_url=redirect_url, domain=K2.domain)
        except Exception as e:
            logging.error(f'Error send mail {str(e)}')
            flash(f'Помилка відправки {e}', 'danger')
        try:
            msg = Message(subject, recipients=[email], html=email_body)
            mail.send(msg)
            try:
                new_email = K2Emails(emailid=K2.generate_id(),
                                     from_email=K2Mail.mail_default_sender,
                                     to_email=email,
                                     message_title=subject,
                                     message=email_body,
                                     active=1,
                                     createdate=datetime.now(time_zone),
                                     updatedate=datetime.now(time_zone),
                                     )
                db.session.add(new_email)
                db.session.commit()
            except Exception as e:
                logging.error(f'Error save mail history to db {str(e)}')
        except Exception as e:
            logging.error(f'Error send mail {str(e)}')
            flash(f'Помилка відправки {e}', 'danger')





app.config['MAIL_SERVER'] = K2Mail.mail_server
app.config['MAIL_PORT'] = K2Mail.mail_port
#app.config['MAIL_USE_TLS'] = K2Mail.mail_use_tls
app.config['MAIL_USE_SSL'] = K2Mail.mail_use_ssl
app.config['MAIL_USERNAME'] = K2Mail.mail_username
app.config['MAIL_PASSWORD'] = K2Mail.mail_password
app.config['MAIL_DEFAULT_SENDER'] = K2Mail.mail_default_sender


mail = Mail(app)



