from flask_sqlalchemy import SQLAlchemy
from sqlalchemy import text
import yaml
import os
import requests
import pytz
import os
import sys
from flask import session, request, redirect, url_for
from flask_login import LoginManager
import platform
#from .k2cfg import K2
import inspect


class K2Obj:
    name = 'k2obj'
    version = ''
    data_source = ['']
    proj_config = yaml.safe_load(open("../proj.yml"))['proj']
    #db = K2.db
    path_objs = [
        f"../cfg/{proj_config}/k2/{name.lower()}.py",
        f"cfg/{name.lower()}.py",
        f"usr/cfg/{name.lower()}.py"
    ]

    def __init__(self):
        self._name_yml = None
        self._html_file = None
        self._name_yml_tree = None
        self._new_buttons = None
        self._name_yml_master = None

    @property
    def name_yml(self):
        """Getter"""
        return self._name_yml

    @name_yml.setter
    def name_yml(self, name: str):
        """Setter method"""
        self._name_yml = name

    @property
    def name_yml_master(self):
        """Getter"""
        return self._name_yml_master

    @name_yml_master.setter
    def name_yml_master(self, name: str):
        """Setter method"""
        self._name_yml_master = name

    @property
    def name_yml_tree(self):
        """Getter"""
        return self._name_yml_tree


    @name_yml_tree.setter
    def name_yml_tree(self, name: str):
        """Setter method"""
        self._name_yml_tree = name


    @property
    def html_file(self):
        """Getter html file"""
        return self._html_file


    @html_file.setter
    def html_file(self, html: str):
        """Setter method"""
        self._html_file = html


    @property
    def new_buttons(self):
        """Getter"""
        return self._new_buttons


    @new_buttons.setter
    def new_buttons(self, name: dict):
        """Setter method"""
        self._new_buttons = name

    def show_grid(self):
        pass

    def select_grid(self):
        pass


    def content(self):
        pass





    @staticmethod
    def create_grid(name_yml: str, html_file: str, new_buttons: dict = None):
        """
        Create handbook with standard grid settings.

    Args:
        name_yml (str): Path to the YAML file containing grid settings.
        html_file (str): Name of the HTML file to render the handbook.

    Returns:
        Flask Response: Rendered template with grid settings.
        """
        try:
            k2grid = K2Grid(name_yml=name_yml)
            if new_buttons is not None:
                k2grid.add_button_toolbar(name_yml, new_buttons)
            return render_template(template_name_or_list=html_file, grid_settings=k2grid)

        except Exception as ex:
            logging.error(f"{ex}")
            return render_template(html_file, error=f"{ex}")


    @staticmethod
    def create_tree_grid(name_yml_tree: str, name_yml: str, html_file: str):
        """
        Create a handbook with a tree structure and additional grid settings.

        Args:
            name_yml_tree (str): Name of the YAML file containing tree structure settings.
            name_yml (str): Name of the YAML file containing additional grid settings.
            html_file (str): Name of the HTML file to render the handbook.

        Returns:
            Flask Response: Rendered template with tree structure and grid settings.

        """
        try:
            k2grid = K2Grid(name_yml=name_yml_tree, type_grid='tree')
            k2grid.add_grid(name_yml=name_yml)
            return render_template(template_name_or_list=html_file, grid_settings=k2grid)
        except Exception as ex:
            logging.error(f"{ex} grid is missing for correct work")
            return render_template(html_file, error=f'{ex}')


    @staticmethod
    def create_master_grid(name_yml, html_file, name_yml_master):
        try:
            k2grid = K2Grid(name_yml=name_yml)
            k2grid.add_grid(name_yml=name_yml_master)
            return render_template(template_name_or_list=html_file,
                                   grid_settings=k2grid)
        except Exception as ex:
            logging.error(f"{ex}")
            return render_template(html_file, error=f"{ex}")


    # Отримуємо значення для розширення поточного класу
    @classmethod
    def get_calling_class_name(cls):
        '''Отримання імені класу, з якого викликається метод'''
        frame = inspect.stack()[1]
        calling_class = frame[0].f_locals.get('self', None)
        if calling_class:
            return calling_class.__class__.__name__
        return None


    #@staticmethod
    def search_class_prop(path_objs):
        '''Пошук властивостей для розширення класу'''
        code_str = None
        for path_obj in path_objs:
            if os.path.exists(path_obj):
                with open(path_obj, 'r') as file:
                    code_str = file.read()
                break  # Виходимо з циклу, якщо знайдено файл
        else:
            sys.exit()  # Завершуємо процес, якщо жоден файл не знайдено
        return code_str


    code_str = search_class_prop(path_objs)
    # @staticmethod
    # def ins_class_prop(code_str):
    try:
        exec(code_str)
    except Exception as e:
        print(f"Error in K2obj {e}")
        sys.exit()

    #ins_class_prop(code_str)

    # code_str = None
    # for path_obj in path_objs:
    #     if os.path.exists(path_obj):
    #         with open(self.path_obj, 'r') as file:
    #             code_str = file.read()
    #         break  # Виходимо з циклу, якщо знайдено файл
    # else:
    #     sys.exit()  # Завершуємо процес, якщо жоден файл не знайдено

   #Вставляємо отримані значення


#print(K2Obj.__dict__)